/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ATOMIC_H
#define ATOMIC_H

#include "common.h"
#include "threads.h"

class Atomic
{
public:
	Atomic(uint64_t value);
	~Atomic();

	uint64_t add(uint32_t inc);
	uint64_t add(uint64_t inc);
	const uint64_t get();

private:
	Atomic(Atomic &a) {}
	Atomic &operator=(Atomic &a) {return *this;}

	uint64_t m_value;
	MUTEX m_mutex;
};

#endif
