/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef REDUX_DIV_BASE_H
#define REDUX_DIV_BASE_H

#include "reduxbruteforce.h"

class DivBase : virtual public ReduxBruteForce
{
public:
	virtual ~DivBase();

	virtual uint64_t hashToIndex(const uint32_t *hash, uint32_t chainPos, uint32_t tableIndex);

protected:
	DivBase(const keySpace &ks, const char *hashFunc);
	void cleanUp();
	void copy(const DivBase &r);

	// Lookup table for "hash64 % m_keySpace"
	uint64_t *m_keySpaceLut;
	uint32_t m_keySpaceLutCount;
};

#endif
