/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GENERATION_THREAD_H
#define GENERATION_THREAD_H

#include "thread.h"
#include "atomic.h"
#include "keyspace.h"
#include "workqueue.h"

struct generationThreadArgs
{
	uint64_t lastStartPoint;
	Atomic *startPoint;
	WorkQueue *outWorkQueue;
	const keySpace *ks;
	const char *hashName, *reduxName;
	uint32_t chainLength, tableIndex, gpuId;
};

class GenerationThread : public Thread
{
public:
	GenerationThread();
	~GenerationThread();
	int stopRunning();

protected:
	void *threadFunc(void *arg);

private:
	GenerationThread(GenerationThread &t) {}
	GenerationThread &operator=(GenerationThread &t) {return *this;}

	uint32_t m_stopRunning;
};

#endif
