/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef KEY_SPACE_H
#define KEY_SPACE_H

#include <vector>
#include <list>
#include "common.h"

struct character
{
	uint32_t size;
	union
	{
		uint32_t charData;
		uint16_t charData2[2];
		uint8_t  charData1[4];
	};
};

typedef std::vector<character>  characterSet;
typedef std::list<characterSet> subKeySpace;
typedef std::list<subKeySpace>  keySpace;

characterSet createCharacterSet(const char *charSet);
uint32_t createKeySpace(keySpace &ks, const char *fileName);
bool operator==(const characterSet &l, const characterSet &r);
uint32_t find(const characterSet &hayStack, const characterSet &needle);
character *strstr(/*const*/ character *hayStack, uint32_t hayStackSize, const characterSet &needle);
uint32_t getMaxLen(const keySpace &ks, uint32_t characterEncoding);
uint32_t getCharSizes(const keySpace &ks);

#endif
