/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef HASH_MD5_H
#define HASH_MD5_H

#include "common.h"

class MD5
{
public:
#ifdef ARC_x86
	static void calcAVXXOP (vector4 *pw, vector4 *hash);
	static void calcAVX    (vector4 *pw, vector4 *hash);
	static void calcSSE2   (vector4 *pw, vector4 *hash);
#endif
	static void calcNorm   (vector4 *pw, vector4 *hash);

private:
	MD5() {}
	static uint32_t initCalc();
	static uint32_t inited;
};

#endif
