/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef REDUX_BRUTE_FORCE_H
#define REDUX_BRUTE_FORCE_H

#include "redux.h"

// CE_FIX_WIDTH_CHAR
class ReduxBruteForce : public Redux
{
public:
	virtual ~ReduxBruteForce();

	virtual uint32_t indexToPw(uint64_t index, uint32_t *pw);

protected:
	ReduxBruteForce(const keySpace &ks, const char *hashFunc);
	void cleanUp();
	void copy(const ReduxBruteForce &r);

	uint64_t *m_keySpaceBoundaries;
	uint32_t *m_passwordLengths, *m_divShortCut, **m_charSetLengths, **m_charSetLengthsFPM;
	int *m_numShortCutChars;
	character *m_charSet, ***m_subKeySpaces;
	uint32_t m_numSubKeySpaces, m_charSetLength;
};

#endif
