/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef REDUX_SINGLE_BYTE_H
#define REDUX_SINGLE_BYTE_H

#include "reduxbruteforce.h"

class ReduxSingleByte : virtual public ReduxBruteForce
{
public:
	virtual ~ReduxSingleByte();

	virtual void indexToHash(const uint64_t *indexes, uint32_t **hashes, uint32_t numIndexes);
	virtual uint32_t indexToPw(uint64_t index, uint32_t *pw);

protected:
	ReduxSingleByte(const keySpace &ks, const char *hashFunc);
	void cleanUp();
	void copy(const ReduxSingleByte &r);

	uint32_t **m_charSetCacheLengths;
	uint16_t *m_charSetCache, ***m_subKeySpacesCache;
	uint32_t **m_charSetCacheLengthsFPM;
	uint8_t *m_charSetSingleByte, ***m_subKeySpacesSingleByte;
	uint32_t m_charSetCacheLength;
};

#endif
