/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef THREAD_H
#define THREAD_H

#include "threads.h"

class Thread
{
public:
	Thread();
	virtual ~Thread() {}
	virtual int stopRunning() = 0;
	void waitForStopRunning();
	int start(void *arg);

protected:
	virtual void *threadFunc(void *arg) = 0;

private:
	Thread(Thread &t) {}
	Thread &operator=(Thread &t) {return *this;}

	static void *callThreadFunc(void *arg);

	void *m_arg;
	THREAD m_thread;
	int m_started;
};

#endif
