/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "write.h"

Write::~Write()
{
	cleanUp();
}

Write::Write()
{
	m_reduxName   = NULL;
	m_hashName    = NULL;
	m_salt        = NULL;
	m_chainLength = 0;
	m_tableIndex  = 0;
}

Write::Write(const char *reduxName, const char *hashName, const char *salt, uint32_t chainLength, uint32_t tableIndex)
{
	strcpy(m_reduxName = new char[strlen(reduxName) + 1], reduxName);
	strcpy(m_hashName  = new char[strlen(hashName)  + 1], hashName);
	if (salt != NULL)
	{
		strcpy(m_salt      = new char[strlen(salt)      + 1], salt);
	}
	else
	{
		m_salt = NULL;
	}
	m_chainLength = chainLength;
	m_tableIndex  = tableIndex;
}

void Write::cleanUp()
{
	if (m_reduxName != NULL)
	{
		delete [] m_reduxName;
		delete [] m_hashName;
		if (m_salt != NULL)
		{
			delete [] m_salt;
		}
		m_reduxName = NULL;
	}
}
