/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef WRITE_H
#define WRITE_H

#include "common.h"

class Write
{
public:
	virtual ~Write();

	virtual uint32_t write(rtChain  *chains, uint32_t count) = 0;
	virtual uint32_t write(crtChain *chains, uint32_t count) = 0;
	virtual void done() = 0;

protected:
	Write();
	Write(const char *reduxName, const char *hashName, const char *salt, uint32_t chainLength, uint32_t tableIndex);
	const __inline__ uint32_t isInited() { return m_reduxName != NULL; }
	void cleanUp();

	char *m_reduxName,  *m_hashName, *m_salt;
	uint32_t m_chainLength, m_tableIndex;
};

#endif
