/*
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This file is part of a set of programs called Advanced TMTO.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef WRITE_RT_H
#define WRITE_RT_H

#include "write.h"
#include <fstream>
#include <string>

class WriteRT : public Write
{
public:
	static Write *create(const char *folder, const char *fileNameComment, const char *reduxName, const char *hashName, const char *salt, const char *keySpaceName, uint32_t chainLength, uint32_t tableIndex);

	~WriteRT();

	uint32_t write(rtChain  *chains, uint32_t count);
	uint32_t write(crtChain *chains, uint32_t count);
	void done();

protected:
	WriteRT &operator=(const WriteRT &r) { return *this; }
	WriteRT(const char *folder, const char *fileNameComment, const char *reduxName, const char *hashName, const char *salt, const char *keySpaceName, uint32_t chainLength, uint32_t tableIndex);
	void cleanUp();

	void nextFile();
	void closeFile();

	static uint32_t initFactory();
	static uint32_t s_inited;

	std::string m_fileName, m_fileName2;
	std::ofstream m_fout;
	uint64_t m_fileChains;
	uint32_t m_fileIndex;
};

#endif
